/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *  JSP-1.4.2 ʹߤѹ줿ߥϥɥؤб
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#if TKERNEL_PRVER >= 0x1042u	/* JSP-1.4.2 ʹ */

#include "h8_sil.h"

/*
 *  ߥץ饤ƥ٥ѤΥǡ¤
 */
static IRC ed_irc = {
	(UB*)ED_IPR,	/* IPR쥸			*/
	ED_IPR_IP_BIT,	/* IPR쥸γӥåֹ	*/
	ED_IPM,		/* ߥ٥				*/
	};

/*
 * ed_dis_inter -- ߤػߤ롣
 */

IPM
ed_dis_inter(void)
{
	IPM	ipm;

	syscall(get_ipm(&ipm));
	syscall(chg_ipm(if_ed_handler_intmask));
	return ipm;
	}

/*
 *  ed_bus_init -- åȰ¸ΥХν
 */

void
ed_bus_init (void)
{
#ifdef INMEM_ONLY

	/* Хͭˤ롣*/
	sil_orb_ddr(IO_PORT1,	0x1f);		/* Enable A0 - A4	*/
	sil_orb_ddr(IO_PORT3,	0xff);		/* Enable D8 - D15	*/
	sil_orb_ddr(IO_PORT8,	H8P8DDR_CS1);	/* Enable CS1		*/
	sil_orb_ddr(IO_PORTB,	H8PBDDR_UCAS);	/* Enable UCAS		*/

#endif	/* of #ifdef INMEM_ONLY */
	}

/*
 *  ed_inter_init -- åȰ¸γߤν
 */

void
ed_inter_init (void)
{
	/* ׵ѥץ饤ƥ٥ꤹ롣*/
	define_int_plevel(&(ed_irc));

	/* NIC γߤĤ롣*/
	bitset((UB*)ED_IER, ED_IER_IP_BIT);
	}

#endif	/* of #if TKERNEL_PRVER >= 0x1042u */
